@ Part of the Tremolo Ogg Vorbis codec.
@
@ Copyright (C) Robin Watts.
@
@ See enclosed ReadMe/First for licensineg details.

	.text

	.global	_vorbis_apply_window

_vorbis_apply_window:
	@ r0 = ogg_int32_t *d
	@ r1 = ogg_int32_t *window[2]
	@ r2 = long *blocksizes
	@ r3 = lW
	MOV	r12,r13
	STMFD	r13!,{r4-r7,r14}
	LDMFD	r12,{r4-r5}
	@ r4 = W
	@ r5 = nW

	LDR	r4,[r2,r4,LSL#2]	@ r4 = n
	LDR	r6,[r2,r3,LSL#2]	@ r6 = ln
	LDR	r2,[r2,r5,LSL#2]	@ r2 = rn
	LDR	r3,[r1,r3,LSL#2]	@ r3 = window[lW]
	LDR	r5,[r1,r5,LSL#2]	@ r5 = window[nW]

        MOV	r1,r0	@ r1 = d

	@ for (i = 0 @ i < leftbegin@ i++)
	@   d[i] = 0@
	MOV	r14,#0
	SUBS	r12,r4,r6	@ r12 = n-ln
vaw_lp:
	STRGT	r14,[r0],#4
	SUBS	r12,r12,#4
	BGT	vaw_lp

	@ for (p = 0@ i < leftend@ i++,p++)
	@   d[i] = MULT31(d[i], window[lW][p])@
	LDR	r7,[r3],#4	@ r7 = *window[lW]++
vaw_lp2:
	LDR	r14,[r0]	@ r14 = d[i]
	SUBS	r6,r6,#2
	SMULL	r12,r14,r7,r14	@ {r12,r14} = *window[lW] * d[i]
	LDRGT	r7,[r3],#4	@ r7 = *window[lW]++
	MOV	r14,r14,LSL#1
	STR	r14,[r0],#4
	BGT	vaw_lp2

	ADD	r1,r1,r4	@ d += n>>2
	ADD	r1,r1,r4,LSL#1	@ d += n>>1
	SUB	r1,r1,r2	@ d -= rn>>2
	ADD	r5,r5,r2,LSL#1	@ r5 = &window[nW][rn>>1]

	SUB	r0,r4,r2	@ r0 = n-rn

	@ for (i=rightbegin,p=(rn>>1)-1@ i<rightend@ i++,p--)
	@   d[i]= MULT31(d[i],window[nW][p])@
	LDR	r7,[r5,#-4]!	@ r7 = --*window[nW]
vaw_lp3:
	LDR	r14,[r1]	@ r14 = d[i]
	SUBS	r2,r2,#2
	SMULL	r12,r14,r7,r14	@ {r12,r14} = *window[nW] * d[i]
	LDRGT	r7,[r5,#-4]!	@ r7 = --*window[nW]
	MOV	r14,r14,LSL#1
	STR	r14,[r1],#4
	BGT	vaw_lp3

	@ for (@i<n@i++)
	@   d[i]=0@
	CMP	r0,#0
	MOV	r14,#0
vaw_lp4:
	STRGT	r12,[r1],#4
	SUBS	r0,r0,#4
	BGT	vaw_lp4

	LDMFD	r13!,{r4-r7,PC}
